# !/usr/local/bin/perl
#
# name  :       netstart.pl
# author:       jolly - who else ?
#
#	This file creates the required network sockets out of the configuration files
#
#
require 'sys/socket.ph';
require 'alias.pl';

$myboottime=time();
chop($myhostname=`hostname`) if !$myhostname;
($name,$aliases,$type,$len,$myhostaddr)=gethostbyname($myhostname);
$hostname{$myhostaddr}=$myhostname;
$hostname{"\0\0\0\0"}="0.0.0.0";

 
# ########
# read in the hardrouted servers
# ########
 
($name,$aliases,$proto)=getprotobyname('udp');
open(CON,"../$myhostname/netconfig") || die $!;
READCONFIG:
while( <CON> )
{
        chop;
        next READCONFIG if /^#/ ;
        next READCONFIG if /^localhost\s+(\d+)\s*$/ && ($myport=$1);
 
        if( /^(\S+)\s+(\d+)\s*$/ )
        {
                ($name,$aliases,$type,$len,$addr)=gethostbyname($1);
                next READCONFIG if $addr eq $myhostaddr;
 
                $paddr=pack('S n a4 x8',&PF_INET,$2,$addr);
                $hardrouted{$addr}=$paddr;
				$removerouting{$addr}=1;
				$mom=gethostbyaddr($addr,&PF_INET);
				($hostname{$addr})=split(/\./,$mom) if !$hostname{$addr};
        }
}
$router{$myhostaddr}=pack('S n a4 x8',&PF_INET,$myport ,$myhostaddr);
close(CON);


# ########
# create the receive and send socket
# ########
 
socket(SENDSOCKET, &PF_INET, &SOCK_DGRAM, $proto)               || die "socket:$
!\n";
socket(RECVSOCKET, &PF_INET, &SOCK_DGRAM, $proto)       || die "socket:$!\n";
$that = pack('S n a4 x8',&PF_INET,$myport,$myhostaddr);
bind(RECVSOCKET,$that)                                  || die "bind:$!\n";
 
vec($rin,fileno(RECVSOCKET),1)=1;

